/*   egkludge.h
* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*            National Center for Biotechnology Information (NCBI)
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government do not place any restriction on its use or reproduction.
*  We would, however, appreciate having the NCBI and the author cited in
*  any work or product based on this material
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
* ===========================================================================
*
* File Name:  egkludge.h
*
* Author:  Jonathan Kans
*
* Version Creation Date:   1/24/05
*
* $Revision: 1.2 $
*
* File Description: Defines allow entrezgene.asn to use old object loaders
*
* Modifications:  
* --------------------------------------------------------------------------
* Date     Name        Description of modification
* -------  ----------  -----------------------------------------------------
*
*
* ==========================================================================
*/


#ifndef _EGKLUDGE_
#define _EGKLUDGE_

#include <objfeat.h>
#include <objloc.h>
#include <objgen.h>
#include <objpub.h>
#include <objegkludge.h>

#define struct_BioSource biosource
#define struct_Gene_ref generef
#define struct_Prot_ref protref
#define struct_RNA_ref rnaref
#define struct_Date date
#define struct_Dbtag struct_EGDbtag
#define struct_method valnode

#define RNARefFree RnaRefFree
#define RNARefAsnRead RnaRefAsnRead
#define RNARefAsnWrite RnaRefAsnWrite

#define DbtagFree EGDbtagFree
#define DbtagAsnRead EGDbtagAsnRead
#define DbtagAsnWrite EGDbtagAsnWrite

#endif /* ndef _EGKLUDGE_ */

